function [ys,check] = Main_steadystate(ys,exe)
global M_

%%
%% Param Values
%%


NumberOfParameters = M_.param_nbr;                            % Number of deep parameters.
for i = 1:NumberOfParameters                                  % Loop...
  paramname = deblank(M_.param_names(i,:));                   %    Get the name of parameter i. 
  eval([ paramname ' = M_.params(' int2str(i) ');']);         %    Get the value of parameter i.
end       
check = 1;
%%
%% Exchange rates
%%
rer_HE      =   1;
rer_UE      =   1;
rer_EH		=	1/rer_HE;
rer_EU		=	1/rer_UE;
rer_HU		=	rer_HE/rer_UE;
rer_UH		=	1/rer_HU;

%%
% Solver
 guess=abs(randn)*ones(10,1);
% guess=ones(6,1);
[res1 fval]     =   fsolve(@steady3, guess);
% while isreal(res1)==0
% guess=abs(randn)*ones(10,1);
% [res1]     =   fsolve(@steady3, guess);
% end
options = optimset('diagnostics','on', 'Display','on','FunValCheck','on','MaxFunEvals',5000, 'MaxIter', 50000,'DiffMaxChange',1,'TolFun',1e-10,'TolX',1e-10);

[res2 fval]    =   fsolve(@steady3, res1,options);
fval
res2
Y_H =res2(1);
Y_U =res2(2);
Y_E =res2(3);
P_sc_H=res2(4);
P_sc_U=res2(5);
P_sc_E=res2(6);
Y_o = res2(7);
B_s_UH = res2(8);
B_s_EH = res2(9);
B_s_EU = res2(10);
%%
%% Home
%%

P_sd_H = 1;

P_sm_HE		=	rer_HE*P_sc_H/P_sc_E;
P_sm_HU		=	rer_HU*P_sc_H/P_sc_U;

P_sm_H      =	(   dlt_HU*P_sm_HU^(r_m/(r_m-1))		+	(1-dlt_HU)*P_sm_HE^(r_m/(r_m-1)))^((r_m-1)/r_m);
P_sno_H = (   (1-dlt_mc_H)*P_sd_H^(r_c/(r_c-1))   +   dlt_mc_H*P_sm_H^(r_c/(r_c-1))  )^((r_c-1)/r_c);

%P_sc_H =  (   (1-dlt_oc_H)*P_sno_H^(r_o/(r_o-1))  +   dlt_oc_H*P_so_H^(r_o/(r_o-1))  )^((r_o-1)/r_o);
P_si_H =  (   (1-dlt_i_H)*P_sd_H^(r_c / (r_c-1))  +   dlt_i_H*P_sm_H^(r_c /(r_c-1))  )^((r_c-1)/r_c);
r_k_H = P_si_H*(1/beta_H - (1-dlt));

theta_o = 1;
psi_o =	(1+theta_o)/theta_o;
P_so_H = (psi_o/(psi_o-1))*((1-beta_H)/beta_H)*r_k_H;


lmbd_sv_H = ((.5^(r_o/(r_o-1)) -   dlt_oy_H*P_so_H^(r_o/(r_o-1)))/(1-dlt_oy_H))^((r_o-1)/r_o);
w_H       = (   (lmbd_sv_H^(r_v/(r_v-1))    -   (1-dlt_l_H)*r_k_H^(r_v/(r_v-1)))/dlt_l_H  )^((r_v-1)/r_v);

%lmbd_sv_H =  (   (1-dlt_l_H)*r_k_H^(r_v/(r_v-1))    +   dlt_l_H*w_H^(r_v/(r_v-1))  )^((r_v-1)/r_v);
mc_H      =  ((1-dlt_oy_H)*lmbd_sv_H^(r_o/(r_o-1))   +   dlt_oy_H*P_so_H^(r_o/(r_o-1))  )^((r_o-1)/r_o);

VA_H =   (1-dlt_oy_H)*(mc_H /lmbd_sv_H)^(1/(1-r_o))*Y_H;
K_y  =   (1-dlt_l_H)*(lmbd_sv_H/r_k_H)^(1/(1-r_v))*VA_H;
L_H  =  dlt_l_H*(lmbd_sv_H/ w_H)^(1/(1-r_v))*VA_H;
O_y_H=      dlt_oy_H*(mc_H /P_so_H)^(1/(1-r_o))*Y_H;

K_o = Y_o;

K_H = K_y + K_o;
I_H=dlt*K_H;
I_d_H =  (1-dlt_i_H)*(P_si_H)^(1/(1-r_c))*I_H;

theta_w_H=1;
psi_w_H	=	(1+theta_w_H)/theta_w_H;
w_f_H = w_H*(psi_w_H-1)/psi_w_H;   

C_H = (chi0*(P_sc_H /w_f_H)*(1-L_H)^(-chi))^(-1 /sig)*(1 /(1-kappa));
C_no_H =  (1-dlt_oc_H)*(P_sc_H /P_sno_H)^(1/(1-r_o))*C_H;
C_d_H =   (1-dlt_mc_H)*(P_sno_H)^(1/(1-r_c))*C_no_H;
O_c_H = dlt_oc_H*(P_sc_H/P_so_H)^(1/(1-r_o))*(mu_zo)^(r_o/(1-r_o))*C_H;

O_H = O_y_H + O_c_H;
G_d_H = g_H*Y_H;

M_c_H   = dlt_mc_H*(P_sno_H/P_sm_H)^(1/(1-r_c))*C_no_H;
M_c_HU  = dlt_HU*(P_sm_H/P_sm_HU)^(1/(1-r_m))*M_c_H;
M_c_HE  = (1-dlt_HU)*(P_sm_H/P_sm_HE)^(1/(1-r_m))*M_c_H;

M_i_H   = dlt_i_H*(P_si_H/P_sm_H)^(1/(1-r_c))*I_H;
M_i_HE  = dlt_HU*(P_sm_H/P_sm_HE)^(1/(1-r_c))*M_i_H;
M_i_HU  = (1-dlt_HU)*(P_sm_H/P_sm_HU)^(1/(1-r_c))*M_i_H;

M_HU = P_sm_HU*(M_i_HU + M_c_HU);
M_HE = P_sm_HE*(M_i_HE + M_c_HE);

M_H		=	M_HU	+	M_HE;


%%
%% US
%%

P_sd_U=1;

P_so_U      =	rer_UH*P_so_H*P_sc_U/P_sc_H;
P_sm_UE		=	rer_UE*P_sc_U/P_sc_E;
P_sm_UH		=	rer_UH*P_sc_U/P_sc_H;
P_sm_U      =	(dlt_UH*P_sm_UH^(r_m/(r_m-1))	+	(1-dlt_UH)*P_sm_UE^(r_m/(r_m-1)))^((r_m-1)/r_m);
P_sno_U = (   (1-dlt_mc_U)*P_sd_U^(r_c/(r_c-1))   +   dlt_mc_U*P_sm_U^(r_c/(r_c-1))  )^((r_c-1)/r_c);

%fval(5) = P_sc_U  - (   (1-dlt_oc_U)*P_sno_U^(r_o/(r_o-1))  +   dlt_oc_U*P_so_U^(r_o/(r_o-1))  )^((r_o-1)/r_o);
P_si_U  = (   (1-dlt_i_U)*P_sd_U^(r_c / (r_c-1))  +   dlt_i_U*P_sm_U^(r_c /(r_c-1))  )^((r_c-1)/r_c);
r_k_U = P_si_U*(1/beta_U - (1-dlt));

lmbd_sv_U = ((.5^(r_o/(r_o-1)) -   dlt_oy_U*P_so_U^(r_o/(r_o-1)))/(1-dlt_oy_U))^((r_o-1)/r_o);
w_U       = (   (lmbd_sv_U^(r_v/(r_v-1))    -   (1-dlt_l_U)*r_k_U^(r_v/(r_v-1)))/dlt_l_U  )^((r_v-1)/r_v);

%lmbd_sv_U =  (   (1-dlt_l_U)*r_k_U^(r_v/(r_v-1))    +   dlt_l_U*w_U^(r_v/(r_v-1))  )^((r_v-1)/r_v);
mc_U      =  ((1-dlt_oy_U)*lmbd_sv_U^(r_o/(r_o-1))   +   dlt_oy_U*P_so_U^(r_o/(r_o-1))  )^((r_o-1)/r_o);

VA_U =   (1-dlt_oy_U)*(mc_U /lmbd_sv_U)^(1/(1-r_o))*Y_U;
K_U  =   (1-dlt_l_U)*(lmbd_sv_U/r_k_U)^(1/(1-r_v))*VA_U;
L_U  =   dlt_l_U*(lmbd_sv_U/ w_U)^(1/(1-r_v))*VA_U;
O_y_U=      dlt_oy_U*(mc_U /P_so_U)^(1/(1-r_o))*Y_U;

I_U=dlt*K_U;
I_d_U =  (1-dlt_i_U)*(P_si_U)^(1/(1-r_c))*I_U;

theta_w_U=1; 
psi_w_U	=	(1+theta_w_U)/theta_w_U;
w_f_U = w_U*(psi_w_U-1)/psi_w_U;  

C_U = (chi0*(P_sc_U /w_f_U)*(1-L_U)^(-chi))^(-1 /sig)*(1 /(1-kappa));
C_no_U =   (1-dlt_oc_U)*(P_sc_U /P_sno_U)^(1/(1-r_o))*C_U;
C_d_U =   (1-dlt_mc_U)*(P_sno_U)^(1/(1-r_c))*C_no_U;
O_c_U = dlt_oc_U*(P_sc_U/P_so_U)^(1/(1-r_o))*(mu_zo)^(r_o/(1-r_o))*C_U;

O_U = O_c_U + O_y_U;

G_d_U = g_U*Y_U;

M_c_U   = dlt_mc_U*(P_sno_U/P_sm_U)^(1/(1-r_c))*C_no_U;
M_c_UH  = dlt_UH*(P_sm_U/P_sm_UH)^(1/(1-r_m))*M_c_U;
M_c_UE  = (1-dlt_UH)*(P_sm_U/P_sm_UE)^(1/(1-r_m))*M_c_U;

M_i_U   = dlt_i_U*(P_si_U/P_sm_U)^(1/(1-r_c))*I_U;
M_i_UE  = dlt_UH*(P_sm_U/P_sm_UE)^(1/(1-r_m))*M_i_U;
M_i_UH  = (1-dlt_UH)*(P_sm_U/P_sm_UH)^(1/(1-r_m))*M_i_U;

M_UH = P_sm_UH*(M_i_UH + M_c_UH);
M_UE = P_sm_UE*(M_i_UE + M_c_UE);

M_U	=	M_UH	+	M_UE;


%%
%% EA
%%

P_sd_E=1;

P_so_E      =	rer_EH*P_so_H*P_sc_E/P_sc_H;
P_sm_EU     =	rer_EU*P_sc_E/P_sc_U;
P_sm_EH		=	rer_EH*P_sc_E/P_sc_H;
P_sm_E      =	((1-dlt_EU)*P_sm_EH^(r_m/(r_m-1))		+	dlt_EU*P_sm_EU^(r_m/(r_m-1)))^((r_m-1)/r_m);
P_sno_E = (   (1-dlt_mc_E)*P_sd_E^(r_c/(r_c-1))   +   dlt_mc_E*P_sm_E^(r_c/(r_c-1))  )^((r_c-1)/r_c);

%P_sc_E  = (   (1-dlt_oc_E)*P_sno_E^(r_o/(r_o-1))  +   dlt_oc_E*P_so_E^(r_o/(r_o-1))  )^((r_o-1)/r_o);
P_si_E  = (   (1-dlt_i_E)*P_sd_E^(r_c / (r_c-1))  +   dlt_i_E*P_sm_E^(r_c /(r_c-1))  )^((r_c-1)/r_c);
r_k_E = P_si_E*(1/beta_E - (1-dlt));

lmbd_sv_E = ((	(.5)^(r_o/(r_o - 1)) -   dlt_oy_E*P_so_E^(r_o/(r_o-1)))/(1-dlt_oy_E))^((r_o-1)/r_o);
w_E = (   (lmbd_sv_E^(r_v/(r_v-1))    -   (1-dlt_l_E)*r_k_E^(r_v/(r_v-1)))/dlt_l_E  )^((r_v-1)/r_v);

%lmbd_sv_E =  (   (1-dlt_l_E)*r_k_E^(r_v/(r_v-1))    +   dlt_l_E*w_E^(r_v/(r_v-1))  )^((r_v-1)/r_v);
mc_E      =  ((1-dlt_oy_E)*lmbd_sv_E^(r_o/(r_o-1))   +   dlt_oy_E*P_so_E^(r_o/(r_o-1))  )^((r_o-1)/r_o);

VA_E =   (1-dlt_oy_E)*(mc_E /lmbd_sv_E)^(1/(1-r_o))*Y_E;
K_E  =   (1-dlt_l_E)*(lmbd_sv_E/r_k_E)^(1/(1-r_v))*VA_E;
L_E  =   dlt_l_E*(lmbd_sv_E/ w_E)^(1/(1-r_v))*VA_E;
O_y_E=      dlt_oy_E*(mc_E /P_so_U)^(1/(1-r_o))*Y_E;

I_E=dlt*K_E;
I_d_E =  (1-dlt_i_E)*(P_si_E)^(1/(1-r_c))*I_E;

theta_w_E=1;        
psi_w_E	=	(1+theta_w_E)/theta_w_E;
w_f_E = w_E*(psi_w_H-1)/psi_w_H;
   
C_E = (chi0*(P_sc_E /w_f_E)*(1-L_E)^(-chi))^(-1 /sig)*(1 /(1-kappa));
C_no_E =   (1-dlt_oc_E)*(P_sc_E /P_sno_E)^(1/(1-r_o))*C_E;
C_d_E =   (1-dlt_mc_E)*(P_sno_E)^(1/(1-r_c))*C_no_E;
O_c_E = dlt_oc_E*(P_sc_E/P_so_U)^(1/(1-r_o))*(mu_zo)^(r_o/(1-r_o))*C_E;

O_E = O_c_E + O_y_E;

G_d_E = g_E*Y_E;

M_c_E   = dlt_mc_E*(P_sno_E/P_sm_E)^(1/(1-r_c))*C_no_E;
M_c_EH  = dlt_EH*(P_sm_E/P_sm_EH)^(1/(1-r_m))*M_c_E;
M_c_EU  = (1-dlt_EH)*(P_sm_E/P_sm_EU)^(1/(1-r_m))*M_c_E;

M_i_E   = dlt_i_E*(P_si_E/P_sm_E)^(1/(1-r_c))*I_E;
M_i_EU  = dlt_EH*(P_sm_E/P_sm_EU)^(1/(1-r_m))*M_i_E;
M_i_EH  = (1-dlt_EH)*(P_sm_E/P_sm_EH)^(1/(1-r_m))*M_i_E;

M_EH = P_sm_EH*(M_i_EH + M_c_EH);
M_EU = P_sm_EU*(M_i_EU + M_c_EU);

M_E	=	M_EH	+	M_EU;

%%
X_H = M_UH + M_EH;

X_U = M_HU + M_EU;

X_E = M_HE + M_UE;
%%
%%
%%

omega_H = 1;    omega_U = 1;    omega_E=1; 
pi_d_H=1;       pi_d_U=1;       pi_d_E=1;

theta_p_H=1;        theta_p_U=1;        theta_p_E=1;        
psi_p_H	=	(1+theta_p_H)/theta_p_H;
psi_p_U	=	(1+theta_p_U)/theta_p_U;
psi_p_E	=	(1+theta_p_E)/theta_p_E;
             	
wstr_H = w_H;   wstr_U = w_U;    wstr_E = w_E;	

omega_l_H=(omega_H)^gama_w_H*pi_d_H^(1-gama_w_H);
omega_l_U=(omega_U)^gama_w_U*pi_d_U^(1-gama_w_U);
omega_l_E=(omega_E)^gama_w_E*pi_d_E^(1-gama_w_E);

S1_w_H = L_H*psi_w_H*w_f_H/((1-rho_w_H*beta_H*omega_H));
S1_w_U = L_U*psi_w_U*w_f_U/((1-rho_w_U*beta_U*omega_U));
S1_w_E = L_E*psi_w_E*w_f_E/((1-rho_w_E*beta_E*omega_E));

S2_w_H = L_H*(psi_w_H-1)*(1+tau_w_H)/(1 - rho_w_H*beta_H*omega_l_H);
S2_w_U = L_U*(psi_w_U-1)*(1+tau_w_U)/(1 - rho_w_U*beta_U*omega_l_U);
S2_w_E = L_E*(psi_w_E-1)*(1+tau_w_E)/(1 - rho_w_E*beta_E*omega_l_E);

pi_l_H	=	pi_d_H^gama_p_H*pi_d_H^(1-gama_p_H);
pi_l_U	=	pi_d_U^gama_p_U*pi_d_U^(1-gama_p_U);
pi_l_E	=	pi_d_E^gama_p_E*pi_d_E^(1-gama_p_E);

S1_p_H = Y_H*psi_p_H*mc_H/(1-beta_H*rho_p_H*pi_d_H);
S1_p_U = Y_U*psi_p_U*mc_U/(1-beta_U*rho_p_U*pi_d_U);
S1_p_E = Y_E*psi_p_E*mc_E/(1-beta_E*rho_p_E*pi_d_E);

S2_p_H = Y_H*(psi_p_H - 1)*(1+tau_p_H)/(1-beta_H*rho_p_H*pi_l_H);
S2_p_U = Y_U*(psi_p_U - 1)*(1+tau_p_U)/(1-beta_U*rho_p_U*pi_l_U);
S2_p_E = Y_E*(psi_p_E - 1)*(1+tau_p_E)/(1-beta_E*rho_p_E*pi_l_E);

P_r_H =1; P_r_U =1; P_r_E =1; 


Lmbd_H = beta_H;    Lmbd_U = beta_U;    Lmbd_E = beta_E;
r_s_H = 1/beta_H;   r_s_U = 1/beta_U;   r_s_E = 1/beta_E;
P_b_H = beta_H;     P_b_U = beta_U;     P_b_E = beta_E;     
Y_d_H = Y_H;        Y_d_U = Y_U;        Y_d_E = Y_E;  
L_d_H = L_H;        L_d_U = L_U;        L_d_E = L_E;  
pi_hd_H =1;         pi_hd_U =1;         pi_hd_E =1; 
pibar_core_H =1;    pibar_core_U =1;    pibar_core_E =1; 
pi_core_H =1;       pi_core_U =1;       pi_core_E =1; 
ygap_H=(1-beta_H)/(beta_H*gamma_y_H);           
ygap_U=(1-beta_U)/(beta_U*gamma_y_U);           
ygap_E=(1-beta_E)/(beta_E*gamma_y_E);
Z_H=1;              Z_U=1;              Z_E=1;              
Z_c_H=1;            Z_c_U=1;            Z_c_E=1;            
Z_o_H=1;            Z_o_U=1;            Z_o_E=1;            
Z_m_H=1;            Z_m_U=1;            Z_m_E=1;            
Z_i_H=1;            Z_i_U=1;            Z_i_E=1;            
Z_g_H=1;            Z_g_U=1;            Z_g_E=1;            

O_x = O_U + O_E;

NTs_H	=	(X_H	-	M_H)	+	P_so_H*O_x;
NTs_U	=	(X_U	-	M_U )	-	P_so_U*O_U;
NTs_E	=	(X_E	-	M_E)	-	P_so_E*O_E;

B_s_HU	=	-	P_sc_H*rer_HU*zetaU*B_s_UH/P_sc_U;
B_s_HE  =	-	P_sc_H*rer_HE*zetaE*B_s_EH/P_sc_E;
B_s_UE	=	-	P_sc_U*rer_UE*(zetaE/zetaU)*B_s_EU/P_sc_E;

phi_b_HU = exp(phi_b*B_s_HU);
phi_b_HE = exp(phi_b*B_s_HE);
phi_b_EH = exp(phi_b*B_s_EH);
phi_b_EU = exp(phi_b*B_s_EU);
phi_b_UE = exp(phi_b*B_s_UE);
phi_b_UH = exp(phi_b*B_s_UH);

q_c_H = ((1-kappa)*C_H)^(-sig)/P_sc_H; 
q_c_U = ((1-kappa)*C_U)^(-sig)/P_sc_U; 
q_c_E = ((1-kappa)*C_E)^(-sig)/P_sc_E;
Q_k_H = beta_H*q_c_H*r_k_H/(1-beta_H*(1-dlt)); 
Q_k_U = beta_U*q_c_U*r_k_U/(1-beta_U*(1-dlt)); 
Q_k_E = beta_E*q_c_E*r_k_E/(1-beta_E*(1-dlt)); 

% %Oil Exporters Specific Variables
F_u = Y_o; F = Y_o;  NF = K_o; O = NF;

S_F = r_k_H; 
r_f = ((1-beta_H)/beta_H)*r_k_H;

u_op = 1; u_nf = 1;  Z_op = 1; Z_nf=1;
mc_o = ((psi_o-1)/psi_o)*P_so_H;
pi_o = 1;
omega_o = pi_o^gama_o*pi_d_H^(1-gama_o);

S1_o = O*psi_o*mc_o/((1-rho_o*beta_H*pi_o));
S2_o = O*(psi_o-1)/(1 - rho_o*beta_H*omega_o);

Pstr_o = P_so_H;


%%
%%
%%



NumberOfEndogenousVariables = M_.endo_nbr;                    % Number of endogenous variables.
ys = zeros(NumberOfEndogenousVariables,1);                    % Initialization of ys (steady state).
for i = 1:NumberOfEndogenousVariables                         % Loop...
  varname = deblank(M_.endo_names(i,:));                      %    Get the name of endogenous variable i.                     
  eval(['ys(' int2str(i) ') = ' varname ';']);                %    Get the steady state value of this variable.
end 

