function [fval] = steady3(z)
global M_


NumberOfParameters = M_.param_nbr;                            % Number of deep parameters.
for i = 1:NumberOfParameters                                  % Loop...
  paramname = deblank(M_.param_names(i,:));                   %    Get the name of parameter i. 
  eval([ paramname ' = M_.params(' int2str(i) ');']);         %    Get the value of parameter i.
end   
%%
%%


%%
%% Exchange rates
%%
rer_HE      =   1;
rer_UE      =   1;
rer_EH		=	1/rer_HE;
rer_EU		=	1/rer_UE;
rer_HU		=	rer_HE/rer_UE;
rer_UH		=	1/rer_HU;

%%
%%
Y_H =z(1);
Y_U=z(2);
Y_E=z(3);
P_sc_H=z(4);
P_sc_U=z(5);
P_sc_E=z(6);
Y_o = z(7);
B_s_UH = z(8);
B_s_EH = z(9);
B_s_EU = z(10);
%%
%% Home
%%

P_sd_H = 1;

P_sm_HE		=	rer_HE*P_sc_H/P_sc_E;
P_sm_HU		=	rer_HU*P_sc_H/P_sc_U;
P_sm_H      =	(   dlt_HU*P_sm_HU^(r_m/(r_m-1))	+	(1-dlt_HU)*P_sm_HE^(r_m/(r_m-1)))^((r_m-1)/r_m);
P_sno_H     =  ((1-dlt_mc_H)*P_sd_H^(r_c/(r_c-1))   +   dlt_mc_H*P_sm_H^(r_c/(r_c-1))  )^((r_c-1)/r_c);


P_si_H =  (   (1-dlt_i_H)*P_sd_H^(r_c / (r_c-1))  +   dlt_i_H*P_sm_H^(r_c /(r_c-1))  )^((r_c-1)/r_c);
r_k_H = P_si_H*(1/beta_H - (1-dlt));

theta_o = 1;
psi_o =	(1+theta_o)/theta_o;
P_so_H = (psi_o/(psi_o-1))*((1-beta_H)/beta_H)*r_k_H;
fval(4) = P_sc_H -  (   (1-dlt_oc_H)*P_sno_H^(r_o/(r_o-1))  +   dlt_oc_H*P_so_H^(r_o/(r_o-1))  )^((r_o-1)/r_o);

lmbd_sv_H = (((.5)^(r_o/(r_o - 1)) -   dlt_oy_H*P_so_H^(r_o/(r_o-1)))/(1-dlt_oy_H))^((r_o-1)/r_o);
w_H       = (   (lmbd_sv_H^(r_v/(r_v-1))    -   (1-dlt_l_H)*r_k_H^(r_v/(r_v-1)))/dlt_l_H  )^((r_v-1)/r_v);

%lmbd_sv_H =  (   (1-dlt_l_H)*r_k_H^(r_v/(r_v-1))    +   dlt_l_H*w_H^(r_v/(r_v-1))  )^((r_v-1)/r_v);
mc_H      =  ((1-dlt_oy_H)*lmbd_sv_H^(r_o/(r_o-1))   +   dlt_oy_H*P_so_H^(r_o/(r_o-1))  )^((r_o-1)/r_o);

VA_H =   (1-dlt_oy_H)*(mc_H /lmbd_sv_H)^(1/(1-r_o))*Y_H;
K_y  =   (1-dlt_l_H)*(lmbd_sv_H/r_k_H)^(1/(1-r_v))*VA_H;
L_H  =  dlt_l_H*(lmbd_sv_H/ w_H)^(1/(1-r_v))*VA_H;
O_y_H=    dlt_oy_H*(mc_H /P_so_H)^(1/(1-r_o))*Y_H;

K_o = Y_o;
K_H = K_y + K_o;

I_H=dlt*K_H;
I_d_H =  (1-dlt_i_H)*(P_si_H)^(1/(1-r_c))*I_H;

theta_w_H=1;
psi_w_H	=	(1+theta_w_H)/theta_w_H;
w_f_H = w_H*(psi_w_H-1)/psi_w_H;   

C_H = (chi0*(P_sc_H /w_f_H)*(1-L_H)^(-chi))^(-1 /sig)*(1 /(1-kappa));
C_no_H =   (1-dlt_oc_H)*(P_sc_H /P_sno_H)^(1/(1-r_o))*C_H;
C_d_H =   (1-dlt_mc_H)*(P_sno_H)^(1/(1-r_c))*C_no_H;
O_c_H = dlt_oc_H*(P_sc_H/P_so_H)^(1/(1-r_o))*(mu_zo)^(r_o/(1-r_o))*C_H;

O_H = O_y_H + O_c_H;
G_d_H = g_H*Y_H;

M_c_H   = dlt_mc_H*(P_sno_H/P_sm_H)^(1/(1-r_c))*C_no_H;
M_c_HU  = dlt_HU*(P_sm_H/P_sm_HU)^(1/(1-r_m))*M_c_H;
M_c_HE  = (1-dlt_HU)*(P_sm_H/P_sm_HE)^(1/(1-r_m))*M_c_H;

M_i_H   = dlt_i_H*(P_si_H/P_sm_H)^(1/(1-r_c))*I_H;
M_i_HE  = dlt_HU*(P_sm_H/P_sm_HE)^(1/(1-r_c))*M_i_H;
M_i_HU  = (1-dlt_HU)*(P_sm_H/P_sm_HU)^(1/(1-r_c))*M_i_H;

M_HU = P_sm_HU*(M_i_HU + M_c_HU);
M_HE = P_sm_HE*(M_i_HE + M_c_HE);

M_H		=	M_HU	+	M_HE;


%%
%% US
%%

P_sd_U=1;

P_so_U      =	rer_UH*P_so_H*P_sc_U/P_sc_H;
P_sm_UE		=	rer_UE*P_sc_U/P_sc_E;
P_sm_UH		=	rer_UH*P_sc_U/P_sc_H;
P_sm_U      =	(dlt_UH*P_sm_UH^(r_m/(r_m-1))	+	(1-dlt_UH)*P_sm_UE^(r_m/(r_m-1)))^((r_m-1)/r_m);
P_sno_U = (   (1-dlt_mc_U)*P_sd_U^(r_c/(r_c-1))   +   dlt_mc_U*P_sm_U^(r_c/(r_c-1))  )^((r_c-1)/r_c);

fval(5) = P_sc_U  - (   (1-dlt_oc_U)*P_sno_U^(r_o/(r_o-1))  +   dlt_oc_U*P_so_U^(r_o/(r_o-1))  )^((r_o-1)/r_o);
P_si_U  = (   (1-dlt_i_U)*P_sd_U^(r_c / (r_c-1))  +   dlt_i_U*P_sm_U^(r_c /(r_c-1))  )^((r_c-1)/r_c);
r_k_U = P_si_U*(1/beta_U - (1-dlt));

lmbd_sv_U = ((	(.5)^(r_o/(r_o - 1)) -   dlt_oy_U*P_so_U^(r_o/(r_o-1)))/(1-dlt_oy_U))^((r_o-1)/r_o);
w_U       = (   (lmbd_sv_U^(r_v/(r_v-1))    -   (1-dlt_l_U)*r_k_U^(r_v/(r_v-1)))/dlt_l_U  )^((r_v-1)/r_v);


%lmbd_sv_U =  (   (1-dlt_l_U)*r_k_U^(r_v/(r_v-1))  +   dlt_l_U*w_U^(r_v/(r_v-1))  )^((r_v-1)/r_v);
mc_U      =  ((1-dlt_oy_U)*lmbd_sv_U^(r_o/(r_o-1))+   dlt_oy_U*P_so_U^(r_o/(r_o-1))  )^((r_o-1)/r_o);

VA_U =   (1-dlt_oy_U)*(mc_U /lmbd_sv_U)^(1/(1-r_o))*Y_U;
K_U  =   (1-dlt_l_U)*(lmbd_sv_U/r_k_U)^(1/(1-r_v))*VA_U;
L_U  =   dlt_l_U*(lmbd_sv_U/ w_U)^(1/(1-r_v))*VA_U;
O_y_U=      dlt_oy_U*(mc_U /P_so_U)^(1/(1-r_o))*Y_U;

I_U=dlt*K_U;
I_d_U =  (1-dlt_i_U)*(P_si_U)^(1/(1-r_c))*I_U;

theta_w_U=1; 
psi_w_U	=	(1+theta_w_U)/theta_w_U;
w_f_U = w_U*(psi_w_U-1)/psi_w_U; 

C_U = (chi0*(P_sc_U /w_f_U)*(1-L_U)^(-chi))^(-1 /sig)*(1 /(1-kappa));
C_no_U =   (1-dlt_oc_U)*(P_sc_U /P_sno_U)^(1/(1-r_o))*C_U;
C_d_U =   (1-dlt_mc_U)*(P_sno_U)^(1/(1-r_c))*C_no_U;
O_c_U = dlt_oc_U*(P_sc_U/P_so_U)^(1/(1-r_o))*(mu_zo)^(r_o/(1-r_o))*C_U;

O_U = O_y_U + O_c_U;

G_d_U = g_U*Y_U;

M_c_U   = dlt_mc_U*(P_sno_U/P_sm_U)^(1/(1-r_c))*C_no_U;
M_c_UH  = dlt_UH*(P_sm_U/P_sm_UH)^(1/(1-r_m))*M_c_U;
M_c_UE  = (1-dlt_UH)*(P_sm_U/P_sm_UE)^(1/(1-r_m))*M_c_U;

M_i_U   = dlt_i_U*(P_si_U/P_sm_U)^(1/(1-r_c))*I_U;
M_i_UE  = dlt_UH*(P_sm_U/P_sm_UE)^(1/(1-r_m))*M_i_U;
M_i_UH  = (1-dlt_UH)*(P_sm_U/P_sm_UH)^(1/(1-r_m))*M_i_U;

M_UH = P_sm_UH*(M_i_UH + M_c_UH);
M_UE = P_sm_UE*(M_i_UE + M_c_UE);

M_U	=	M_UH	+	M_UE;


%%
%% EA
%%

P_sd_E=1;

P_so_E      =	rer_EH*P_so_H*P_sc_E/P_sc_H;
P_sm_EU     =	rer_EU*P_sc_E/P_sc_U;
P_sm_EH		=	rer_EH*P_sc_E/P_sc_H;
P_sm_E      =	((1-dlt_EU)*P_sm_EH^(r_m/(r_m-1))		+	dlt_EU*P_sm_EU^(r_m/(r_m-1)))^((r_m-1)/r_m);
P_sno_E = (   (1-dlt_mc_E)*P_sd_E^(r_c/(r_c-1))   +   dlt_mc_E*P_sm_E^(r_c/(r_c-1))  )^((r_c-1)/r_c);

fval(6) = P_sc_E  - (   (1-dlt_oc_E)*P_sno_E^(r_o/(r_o-1))  +   dlt_oc_E*P_so_E^(r_o/(r_o-1))  )^((r_o-1)/r_o);
P_si_E  = (   (1-dlt_i_E)*P_sd_E^(r_c / (r_c-1))  +   dlt_i_E*P_sm_E^(r_c /(r_c-1))  )^((r_c-1)/r_c);
r_k_E = P_si_E*(1/beta_E - (1-dlt));

lmbd_sv_E = ((	(.5)^(r_o/(r_o - 1)) -   dlt_oy_E*P_so_E^(r_o/(r_o-1)))/(1-dlt_oy_E))^((r_o-1)/r_o);
w_E = (   (lmbd_sv_E^(r_v/(r_v-1))    -   (1-dlt_l_E)*r_k_U^(r_v/(r_v-1)))/dlt_l_E  )^((r_v-1)/r_v);

%lmbd_sv_E =  (   (1-dlt_l_E)*r_k_E^(r_v/(r_v-1))    +   dlt_l_E*w_E^(r_v/(r_v-1))  )^((r_v-1)/r_v);
mc_E      =  ((1-dlt_oy_E)*lmbd_sv_E^(r_o/(r_o-1))   +   dlt_oy_E*P_so_E^(r_o/(r_o-1))  )^((r_o-1)/r_o);

VA_E =   (1-dlt_oy_E)*(mc_E /lmbd_sv_E)^(1/(1-r_o))*Y_E;
K_E  =   (1-dlt_l_E)*(lmbd_sv_E/r_k_E)^(1/(1-r_v))*VA_E;
L_E  =   dlt_l_E*(lmbd_sv_E/ w_E)^(1/(1-r_v))*VA_E;
O_y_E=      dlt_oy_E*(mc_E /P_so_U)^(1/(1-r_o))*Y_E;

I_E=dlt*K_E;
I_d_E =  (1-dlt_i_E)*(P_si_E)^(1/(1-r_c))*I_E;

theta_w_E=1;        
psi_w_E	=	(1+theta_w_E)/theta_w_E;
w_f_E = w_E*(psi_w_H-1)/psi_w_H;

C_E = (chi0*(P_sc_E /w_f_E)*(1-L_E)^(-chi))^(-1 /sig)*(1 /(1-kappa));
C_no_E =   (1-dlt_oc_E)*(P_sc_E /P_sno_E)^(1/(1-r_o))*C_E;
C_d_E =   (1-dlt_mc_E)*(P_sno_E)^(1/(1-r_c))*C_no_E;
O_c_E = dlt_oc_E*(P_sc_E/P_so_U)^(1/(1-r_o))*(mu_zo)^(r_o/(1-r_o))*C_E;

O_E = O_y_E + O_c_E;

G_d_E = g_E*Y_E;

M_c_E   = dlt_mc_E*(P_sno_E/P_sm_E)^(1/(1-r_c))*C_no_E;
M_c_EH  = dlt_EH*(P_sm_E/P_sm_EH)^(1/(1-r_m))*M_c_E;
M_c_EU  = (1-dlt_EH)*(P_sm_E/P_sm_EU)^(1/(1-r_m))*M_c_E;

M_i_E   = dlt_i_E*(P_si_E/P_sm_E)^(1/(1-r_c))*I_E;
M_i_EU  = dlt_EH*(P_sm_E/P_sm_EU)^(1/(1-r_m))*M_i_E;
M_i_EH  = (1-dlt_EH)*(P_sm_E/P_sm_EH)^(1/(1-r_m))*M_i_E;

M_EH = P_sm_EH*(M_i_EH + M_c_EH);
M_EU = P_sm_EU*(M_i_EU + M_c_EU);

M_E	=	M_EH	+	M_EU;

%%
%%
X_H = M_UH + M_EH;

X_E = M_HE + M_UE;

X_U = M_HU + M_EU;

O_x = O_U  + O_E;

%%
%%
NTs_H	=	(X_H	-	M_H)	+	P_so_H*O_x;
NTs_U	=	(X_U	-	M_U )	-	P_so_U*O_U;
NTs_E	=	(X_E	-	M_E)	-	P_so_E*O_E;

B_s_HU	=	-	P_sc_H*rer_HU*zetaU*B_s_UH/P_sc_U;
B_s_HE  =	-	P_sc_H*rer_HE*zetaE*B_s_EH/P_sc_E;
B_s_UE	=	-	P_sc_U*rer_UE*(zetaE/zetaU)*B_s_EU/P_sc_E;

phi_b_HU = exp(phi_b*B_s_HU);
phi_b_HE = exp(phi_b*B_s_HE);
phi_b_EH = exp(phi_b*B_s_EH);
phi_b_EU = exp(phi_b*B_s_EU);
phi_b_UE = exp(phi_b*B_s_UE);
phi_b_UH = exp(phi_b*B_s_UH);
P_b_H = beta_H;     P_b_U = beta_U;     P_b_E = beta_E;

fval(8)  = B_s_HU*( P_b_U/phi_b_HU - 1)    +   B_s_HE*( P_b_E/phi_b_HE - 1)  - NTs_H;
fval(9)  = B_s_UH*( P_b_H/phi_b_UH - 1)    +   B_s_UE*( P_b_E/phi_b_UE - 1)  - NTs_U;
fval(10) = B_s_EH*( P_b_H/phi_b_EH - 1)    +   B_s_EU*( P_b_U/phi_b_EU - 1)  - NTs_E;   

%%
%%


fval(1) = Y_H - C_d_H - I_d_H - G_d_H - (X_H );

fval(2) = Y_E - C_d_E - I_d_E - G_d_E - (X_E );

fval(3) = Y_U - C_d_U - I_d_U - G_d_U - (X_U );

fval(7) = Y_o - O_H - O_x;




